import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.html.*;
import com.ms.win32.*; 

/*
FastMode sample
Copyright (c)1997-2004 Hai Li, Zeal SoftStudio.
E-Mail: support@zealsoft.com
Web: http://www.zealsoft.com
This sample illustrates how to use the fast mode of
NTPort Library to increase performance.
*/

/**
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'Form1' is
 * created in the main() method.
 */
public class Form1 extends Form
{
	public Form1()
	{
		// Required for Visual J++ Form Designer support
		initForm();		

		// TODO: Add any constructor code after initForm call
		// After register NTPort Library,
		// place your registration information here.
		NTPort.LicenseInfo("Your Name", 0);
	}

	/**
	 * Form1 overrides dispose so it can clean up the
	 * component list.
	 */
	public void dispose()
	{
		super.dispose();
		components.dispose();
	}

	// Get high performance time
	public long GetHiResTime()
	{
		long[] freq = new long[1];
		long[] cnt = new long[1];
		if(Kernel32.QueryPerformanceFrequency(freq))
		{
			Kernel32.QueryPerformanceCounter(cnt);
			return (long)(cnt[0] / (double)freq[0] * 1000);			
		}
		else
			return Winmm.timeGetTime();
	}
	
	private void btnFast_click(Object source, Event e)
	{
		StringBuffer sz = new StringBuffer(255);
		int i, nData;
		long tTime;

		// Check the OS
		if(!NTPort.IsWinNT())
		{
			User32.MessageBox(this.getHandle(), 
					   "Fast mode is designed for Windows NT/2000/XP, not Windows 95/98.", 
					   "Notice", win.MB_ICONHAND);
			return;
		}

		// Get the address of the port
		short nAddress = Integer.valueOf(edit1.getText()).shortValue();
		short nTimes = Integer.valueOf(edit2.getText()).shortValue();

		// Use fast mode
		NTPort.SetFastMode(true);
		
		// To use the fast mode, you must call EnablePorts
		// before you call the Inport, Outport, and other
		// functions.
		NTPort.EnablePorts(nAddress, nAddress);

		// Test the result of EnablePorts
		if(NTPort.GetLastState(sz) != NTPort.ERROR_NONE)
		{
			User32.MessageBox(this.getHandle(), sz.toString(), "Error", win.MB_ICONHAND);
		    return;
		}

		// If you are using Evaluation version, this
		// statement will show the registration reminder
		// dialog. If you are using the registered version,
		// please call LicesnseInfo instead.
		nData = NTPort.Inp(nAddress);

		// Start the time count
		tTime = GetHiResTime();

		// Read the port in a loop
		for( i = 1; i < nTimes; i++) 
		    nData = NTPort.Inp(nAddress);

		// Stop the time count
		tTime = GetHiResTime() - tTime;

		// Free the resource
		NTPort.DisablePorts(nAddress, nAddress);

		String s;
		s = "Fast mode time cost: " + String.valueOf(tTime) + "ms";
		// Show the result
		label3.setText(s);		
	}

	private void btnNormal_click(Object source, Event e)
	{
		StringBuffer sz = new StringBuffer(255);
		int i, nData;
		long tTime;

		// Get the address of the port
		short nAddress = Integer.valueOf(edit1.getText()).shortValue();
		short nTimes = Integer.valueOf(edit2.getText()).shortValue();

		// Use fast mode
		NTPort.SetFastMode(false);
		
		// Test the result of EnablePorts
		if(NTPort.GetLastState(sz) != NTPort.ERROR_NONE)
		{
			User32.MessageBox(this.getHandle(), sz.toString(), "Error", win.MB_ICONHAND);
		    return;
		}

		// If you are using Evaluation version, this
		// statement will show the registration reminder
		// dialog. If you are using the registered version,
		// please call LicesnseInfo instead.
		nData = NTPort.Inp(nAddress);

		// Start the time count
		tTime = GetHiResTime();

		// Read the port in a loop
		for( i = 1; i < nTimes; i++) 
		    nData = NTPort.Inp(nAddress);

		// Stop the time count
		tTime = GetHiResTime() - tTime;

		String s;
		s = "Normal mode time cost: " + String.valueOf(tTime) + "ms";
		// Show the result
		label4.setText(s);		
		
	}

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */
	Container components = new Container();
	Label label1 = new Label();
	Edit edit1 = new Edit();
	Label label2 = new Label();
	Edit edit2 = new Edit();
	Label label3 = new Label();
	Label label4 = new Label();
	Button btnFast = new Button();
	Button btnNormal = new Button();
	Label label5 = new Label();

	private void initForm()
	{
		this.setText("Fast Mode Demo");
		this.setAutoScaleBaseSize(new Point(6, 12));
		this.setClientSize(new Point(372, 144));
		this.setMaximizeBox(false);
		this.setMinimizeBox(false);

		label1.setLocation(new Point(8, 16));
		label1.setSize(new Point(80, 16));
		label1.setTabIndex(2);
		label1.setTabStop(false);
		label1.setText("I/O Address:");

		edit1.setLocation(new Point(88, 16));
		edit1.setSize(new Point(72, 19));
		edit1.setTabIndex(3);
		edit1.setText("200");

		label2.setLocation(new Point(168, 16));
		label2.setSize(new Point(48, 16));
		label2.setTabIndex(0);
		label2.setTabStop(false);
		label2.setText("Times:");

		edit2.setLocation(new Point(216, 16));
		edit2.setSize(new Point(72, 19));
		edit2.setTabIndex(1);
		edit2.setText("1000");

		label3.setLocation(new Point(16, 56));
		label3.setSize(new Point(256, 16));
		label3.setTabIndex(5);
		label3.setTabStop(false);
		label3.setText("Click the \"Fast Mode\" button to test!");

		label4.setLocation(new Point(16, 80));
		label4.setSize(new Point(256, 16));
		label4.setTabIndex(4);
		label4.setTabStop(false);
		label4.setText("Click the \"Normal Mode\" button to test!");

		btnFast.setLocation(new Point(280, 48));
		btnFast.setSize(new Point(75, 23));
		btnFast.setTabIndex(7);
		btnFast.setText("Fast Mode");
		btnFast.addOnClick(new EventHandler(this.btnFast_click));

		btnNormal.setLocation(new Point(280, 80));
		btnNormal.setSize(new Point(75, 23));
		btnNormal.setTabIndex(6);
		btnNormal.setText("Normal Mode");
		btnNormal.addOnClick(new EventHandler(this.btnNormal_click));

		label5.setLocation(new Point(8, 120));
		label5.setSize(new Point(344, 16));
		label5.setTabIndex(8);
		label5.setTabStop(false);
		label5.setText("Copyright (c) 1997-2004 Hai Li, Zeal SoftStudio.");

		this.setNewControls(new Control[] {
							label5, 
							btnNormal, 
							btnFast, 
							label4, 
							label3, 
							edit2, 
							label2, 
							edit1, 
							label1});
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main(String args[])
	{
		Application.run(new Form1());
	}
}
