import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.html.*;

/*

PortTest Sample
Copyright (c) 1997-2004 Hai Li, Zeal SoftStudio.
E-Mail: support@zealsoft.com
Web: http://www.zealsoft.com
This sample illustrates how to use NTPort
Library to read or write PC I/O ports.
*/

/**
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'Form1' is
 * created in the main() method.
 */
public class Form1 extends Form
{
	public Form1()
	{
		// Required for Visual J++ Form Designer support
		initForm();		

		// TODO: Add any constructor code after initForm call
		// After register NTPort Library,
		// place your registration information here.
		NTPort.LicenseInfo("Your Name", 0);
	}

	/**
	 * Form1 overrides dispose so it can clean up the
	 * component list.
	 */
	public void dispose()
	{
		super.dispose();
		components.dispose();
	}

	private void btnRead_click(Object source, Event e)
	{
		int inNum;
		short portAdd;

		portAdd = Integer.valueOf(edit1.getText(), 16).shortValue();

		if(radioButton1.getChecked())
		{
			inNum = (int)NTPort.Inport(portAdd);
		}		
		else if(radioButton2.getChecked())
		{
			inNum = (int)NTPort.InportW(portAdd);
		}
		else
		{
			inNum = NTPort.InportD(portAdd);
		}

		listBox1.addItem("In 0x" + Integer.toHexString(portAdd) + ", 0x" + Integer.toHexString(inNum));

		StringBuffer sError = new StringBuffer(255);
		NTPort.GetLastState(sError);
		listBox1.setSelectedIndex(listBox1.addItem(sError.toString()));		
	}

	private void btnWrite_click(Object source, Event e)
	{
		int outNum;
		short portAdd;

		portAdd = Integer.valueOf(edit1.getText(), 16).shortValue();
		outNum = Integer.valueOf(edit2.getText(), 16).intValue();

		if(radioButton1.getChecked())
		{
			NTPort.Outport(portAdd, (short)outNum);
		}		
		else if(radioButton2.getChecked())
		{
			NTPort.OutportW(portAdd, (short)outNum);
		}
		else
		{
			NTPort.OutportD(portAdd, (int)outNum);
		}

		listBox1.addItem("Out 0x" + Integer.toHexString(portAdd) + ", 0x" + Integer.toHexString(outNum));

		StringBuffer sError = new StringBuffer(255);
		NTPort.GetLastState(sError);
		listBox1.setSelectedIndex(listBox1.addItem(sError.toString()));		
	}

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */
	Container components = new Container();
	Label label1 = new Label();
	Edit edit1 = new Edit();
	Label label2 = new Label();
	Edit edit2 = new Edit();
	Button btnRead = new Button();
	Button btnWrite = new Button();
	ListBox listBox1 = new ListBox();
	GroupBox groupBox1 = new GroupBox();
	RadioButton radioButton1 = new RadioButton();
	RadioButton radioButton2 = new RadioButton();
	RadioButton radioButton3 = new RadioButton();
	Label label3 = new Label();
	Label label4 = new Label();

	private void initForm()
	{
		this.setText("PortTest Sample");
		this.setAutoScaleBaseSize(new Point(6, 12));
		this.setClientSize(new Point(368, 260));
		this.setMaximizeBox(false);
		this.setMinimizeBox(false);

		label1.setLocation(new Point(8, 16));
		label1.setSize(new Point(88, 16));
		label1.setTabIndex(0);
		label1.setTabStop(false);
		label1.setText("Address(Hex):");

		edit1.setLocation(new Point(96, 16));
		edit1.setSize(new Point(56, 19));
		edit1.setTabIndex(1);
		edit1.setText("2c");

		label2.setLocation(new Point(160, 16));
		label2.setSize(new Point(48, 16));
		label2.setTabIndex(2);
		label2.setTabStop(false);
		label2.setText("Value:");

		edit2.setLocation(new Point(208, 16));
		edit2.setSize(new Point(64, 19));
		edit2.setTabIndex(3);
		edit2.setText("0");

		btnRead.setLocation(new Point(288, 8));
		btnRead.setSize(new Point(64, 24));
		btnRead.setTabIndex(4);
		btnRead.setText("Inport");
		btnRead.addOnClick(new EventHandler(this.btnRead_click));

		btnWrite.setLocation(new Point(288, 40));
		btnWrite.setSize(new Point(64, 24));
		btnWrite.setTabIndex(5);
		btnWrite.setText("Outport");
		btnWrite.addOnClick(new EventHandler(this.btnWrite_click));

		listBox1.setLocation(new Point(8, 56));
		listBox1.setSize(new Point(264, 124));
		listBox1.setTabIndex(6);
		listBox1.setText("listBox1");
		listBox1.setUseTabStops(true);

		groupBox1.setLocation(new Point(8, 192));
		groupBox1.setSize(new Point(344, 40));
		groupBox1.setTabIndex(7);
		groupBox1.setTabStop(false);
		groupBox1.setText("&Length");

		radioButton1.setLocation(new Point(8, 16));
		radioButton1.setSize(new Point(72, 16));
		radioButton1.setTabIndex(0);
		radioButton1.setTabStop(true);
		radioButton1.setText("&BYTE");
		radioButton1.setChecked(true);

		radioButton2.setLocation(new Point(128, 16));
		radioButton2.setSize(new Point(88, 16));
		radioButton2.setTabIndex(1);
		radioButton2.setText("&WORD");

		radioButton3.setLocation(new Point(264, 16));
		radioButton3.setSize(new Point(72, 16));
		radioButton3.setTabIndex(2);
		radioButton3.setText("&DWORD");

		label3.setLocation(new Point(8, 240));
		label3.setSize(new Point(344, 16));
		label3.setTabIndex(8);
		label3.setTabStop(false);
		label3.setText("Copyright (c) 1997-2004 Hai Li, Zeal SoftStudio.");

		label4.setLocation(new Point(8, 40));
		label4.setSize(new Point(80, 16));
		label4.setTabIndex(9);
		label4.setTabStop(false);
		label4.setText("Result:");

		this.setNewControls(new Control[] {
							label4, 
							label3, 
							groupBox1, 
							listBox1, 
							btnWrite, 
							btnRead, 
							edit2, 
							label2, 
							edit1, 
							label1});
		groupBox1.setNewControls(new Control[] {
								 radioButton3, 
								 radioButton2, 
								 radioButton1});
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main(String args[])
	{
		Application.run(new Form1());
	}
}
