import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.html.*;
			 
/*
 PC Speaker sample
 Copyright (c) 1997-2004 Hai Li, Zeal SoftStudio.
 EMail: support@zealsoft.com
 Web: http://www.zealsoftstudio.com
 This sample illustrates how to use NTPort
 Library to control PC speaker. 
*/

/**
 * This class can take a variable number of parameters on the command
 * line. Program execution begins with the main() method. The class
 * constructor is not invoked unless an object of type 'Form1' is
 * created in the main() method.
 */
public class Form1 extends Form
{
	public Form1()
	{
		// Required for Visual J++ Form Designer support
		initForm();		

		// TODO: Add any constructor code after initForm call
		// After register NTPort Library,
		// place your registration information here.
		NTPort.LicenseInfo("Your Name", 0);
	}

	/**
	 * Form1 overrides dispose so it can clean up the
	 * component list.
	 */
	public void dispose()
	{
		super.dispose();
		components.dispose();
	}

	private void Speaker(boolean bOn)
	{
	    short nValue;
		StringBuffer s = new StringBuffer(255);
	    
	    nValue = NTPort.Inport((short)0x61);
	    if(bOn)
		{
	        nValue |= (short) 3;
	        nValue = 0x2F;

			// Get the state returned from NTPort Library
	        NTPort.GetLastState(s);
	        label2.setText(s.toString());
		}
		else
		{
	        nValue &= ~3;
	    }
	    NTPort.Outport((short)0x61, nValue);
	}

	// Speaker freq is set by setting divider in Intel
	// 8253/8254 timer chip at port addresses 0x42 through 0x43
	private void SetFreq(int nFreq)
	{
		final int Clk8253 = 1193180;
		short nDivider;
		
		if(nFreq != 0)
		{
			nDivider =  (short)(Clk8253 / nFreq);
			NTPort.Outport((short)0x43, (short)0xb6);		// timer 2, square wave
			NTPort.Outport((short)0x42, (short)(nDivider % 256));
			NTPort.Outport((short)0x42, (short)(nDivider / 256));
			Speaker(true);
		}
		else
		{
			Speaker(false);
		}
	}

	private void btnSoundOn_click(Object source, Event e)
	{
	    SetFreq( Integer.valueOf(edit1.getText()).intValue());		
	}

	private void btnSoundOff_click(Object source, Event e)
	{
		Speaker(false);
	}

	/**
	 * NOTE: The following code is required by the Visual J++ form
	 * designer.  It can be modified using the form editor.  Do not
	 * modify it using the code editor.
	 */
	Container components = new Container();
	Label label1 = new Label();
	Edit edit1 = new Edit();
	Button btnSoundOn = new Button();
	Button btnSoundOff = new Button();
	Label label2 = new Label();
	Label label3 = new Label();

	private void initForm()
	{
		this.setText("Speaker Sample");
		this.setAutoScaleBaseSize(new Point(6, 12));
		this.setClientSize(new Point(357, 89));
		this.setMaximizeBox(false);
		this.setMinimizeBox(false);

		label1.setLocation(new Point(8, 8));
		label1.setSize(new Point(88, 24));
		label1.setTabIndex(0);
		label1.setTabStop(false);
		label1.setText("Freqency(Hz):");

		edit1.setLocation(new Point(96, 8));
		edit1.setSize(new Point(56, 19));
		edit1.setTabIndex(1);
		edit1.setText("262");

		btnSoundOn.setLocation(new Point(192, 8));
		btnSoundOn.setSize(new Point(72, 24));
		btnSoundOn.setTabIndex(2);
		btnSoundOn.setText("Sound On");
		btnSoundOn.addOnClick(new EventHandler(this.btnSoundOn_click));

		btnSoundOff.setLocation(new Point(280, 8));
		btnSoundOff.setSize(new Point(64, 24));
		btnSoundOff.setTabIndex(3);
		btnSoundOff.setText("Sound Off");
		btnSoundOff.addOnClick(new EventHandler(this.btnSoundOff_click));

		label2.setLocation(new Point(8, 40));
		label2.setSize(new Point(336, 16));
		label2.setTabIndex(4);
		label2.setTabStop(false);
		label2.setText("label2");

		label3.setLocation(new Point(8, 64));
		label3.setSize(new Point(344, 16));
		label3.setTabIndex(5);
		label3.setTabStop(false);
		label3.setText("Copyright (c) 1997-2004 Zeal SoftStudio. www.zealsoft.com");

		this.setNewControls(new Control[] {
							label3, 
							label2, 
							btnSoundOff, 
							btnSoundOn, 
							edit1, 
							label1});
	}

	/**
	 * The main entry point for the application. 
	 *
	 * @param args Array of parameters passed to the application
	 * via the command line.
	 */
	public static void main(String args[])
	{
		Application.run(new Form1());
	}
}
